<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Simple getopt alternative."><meta name="keywords" content="rust, rustlang, rust-lang, getopts"><title>getopts - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="../crates.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="icon" href="https://www.rust-lang.org/favicon.ico"></head><body class="rustdoc mod crate"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../getopts/index.html"><div class="logo-container"><img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../getopts/index.html"><div class="logo-container">
                    <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a><h2 class="location"><a href="#">Crate getopts</a></h2><div class="sidebar-elems"><div class="block"><ul><li class="version">Version 0.2.21</li><li><a id="all-types" href="all.html">All Items</a></li></ul></div><section><div class="block"><ul><li><a href="#structs">Structs</a></li><li><a href="#enums">Enums</a></li><li><a href="#types">Type Definitions</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../getopts/index.html">
                        <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Crate <a class="mod" href="#">getopts</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/getopts/lib.rs.html#13-1046">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Simple getopt alternative.</p>
<p>Construct a vector of options, either by using <code>reqopt</code>, <code>optopt</code>, and
<code>optflag</code> or by building them from components yourself, and pass them to
<code>getopts</code>, along with a vector of actual arguments (not including
<code>argv[0]</code>). You’ll either get a failure code back, or a match. You’ll have
to verify whether the amount of ‘free’ arguments in the match is what you
expect. Use <code>opt_*</code> accessors to get argument values out of the matches
object.</p>
<p>Single-character options are expected to appear on the command line with a
single preceding dash; multiple-character options are expected to be
proceeded by two dashes. Options that expect an argument accept their
argument following either a space or an equals sign. Single-character
options don’t require the space.</p>
<h2 id="usage"><a href="#usage">Usage</a></h2>
<p>This crate is <a href="https://crates.io/crates/getopts">on crates.io</a> and can be
used by adding <code>getopts</code> to the dependencies in your project’s <code>Cargo.toml</code>.</p>
<div class="example-wrap"><pre class="language-toml"><code>[dependencies]
getopts = &quot;0.2&quot;</code></pre></div>
<p>and this to your crate root:</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">getopts</span>;</code></pre></div>
<h2 id="example"><a href="#example">Example</a></h2>
<p>The following example shows simple command line parsing for an application
that requires an input file to be specified, accepts an optional output file
name following <code>-o</code>, and accepts both <code>-h</code> and <code>--help</code> as optional flags.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">getopts</span>;
<span class="kw">use</span> <span class="ident">getopts::Options</span>;
<span class="kw">use</span> <span class="ident">std::env</span>;

<span class="kw">fn</span> <span class="ident">do_work</span>(<span class="ident">inp</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>, <span class="ident">out</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>) {
    <span class="macro">println!</span>(<span class="string">&quot;{}&quot;</span>, <span class="ident">inp</span>);
    <span class="kw">match</span> <span class="ident">out</span> {
        <span class="prelude-val">Some</span>(<span class="ident">x</span>) =&gt; <span class="macro">println!</span>(<span class="string">&quot;{}&quot;</span>, <span class="ident">x</span>),
        <span class="prelude-val">None</span> =&gt; <span class="macro">println!</span>(<span class="string">&quot;No Output&quot;</span>),
    }
}

<span class="kw">fn</span> <span class="ident">print_usage</span>(<span class="ident">program</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>, <span class="ident">opts</span>: <span class="ident">Options</span>) {
    <span class="kw">let</span> <span class="ident">brief</span> <span class="op">=</span> <span class="macro">format!</span>(<span class="string">&quot;Usage: {} FILE [options]&quot;</span>, <span class="ident">program</span>);
    <span class="macro">print!</span>(<span class="string">&quot;{}&quot;</span>, <span class="ident">opts</span>.<span class="ident">usage</span>(<span class="kw-2">&amp;</span><span class="ident">brief</span>));
}

<span class="kw">fn</span> <span class="ident">main</span>() {
    <span class="kw">let</span> <span class="ident">args</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">env::args</span>().<span class="ident">collect</span>();
    <span class="kw">let</span> <span class="ident">program</span> <span class="op">=</span> <span class="ident">args</span>[<span class="number">0</span>].<span class="ident">clone</span>();

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">opts</span> <span class="op">=</span> <span class="ident">Options::new</span>();
    <span class="ident">opts</span>.<span class="ident">optopt</span>(<span class="string">&quot;o&quot;</span>, <span class="string">&quot;&quot;</span>, <span class="string">&quot;set output file name&quot;</span>, <span class="string">&quot;NAME&quot;</span>);
    <span class="ident">opts</span>.<span class="ident">optflag</span>(<span class="string">&quot;h&quot;</span>, <span class="string">&quot;help&quot;</span>, <span class="string">&quot;print this help menu&quot;</span>);
    <span class="kw">let</span> <span class="ident">matches</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">opts</span>.<span class="ident">parse</span>(<span class="kw-2">&amp;</span><span class="ident">args</span>[<span class="number">1</span>..]) {
        <span class="prelude-val">Ok</span>(<span class="ident">m</span>) =&gt; { <span class="ident">m</span> }
        <span class="prelude-val">Err</span>(<span class="ident">f</span>) =&gt; { <span class="macro">panic!</span>(<span class="ident">f</span>.<span class="ident">to_string</span>()) }
    };
    <span class="kw">if</span> <span class="ident">matches</span>.<span class="ident">opt_present</span>(<span class="string">&quot;h&quot;</span>) {
        <span class="ident">print_usage</span>(<span class="kw-2">&amp;</span><span class="ident">program</span>, <span class="ident">opts</span>);
        <span class="kw">return</span>;
    }
    <span class="kw">let</span> <span class="ident">output</span> <span class="op">=</span> <span class="ident">matches</span>.<span class="ident">opt_str</span>(<span class="string">&quot;o&quot;</span>);
    <span class="kw">let</span> <span class="ident">input</span> <span class="op">=</span> <span class="kw">if</span> <span class="op">!</span><span class="ident">matches</span>.<span class="ident">free</span>.<span class="ident">is_empty</span>() {
        <span class="ident">matches</span>.<span class="ident">free</span>[<span class="number">0</span>].<span class="ident">clone</span>()
    } <span class="kw">else</span> {
        <span class="ident">print_usage</span>(<span class="kw-2">&amp;</span><span class="ident">program</span>, <span class="ident">opts</span>);
        <span class="kw">return</span>;
    };
    <span class="ident">do_work</span>(<span class="kw-2">&amp;</span><span class="ident">input</span>, <span class="ident">output</span>);
}</code></pre></div>
</div></details><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Matches.html" title="getopts::Matches struct">Matches</a></div><div class="item-right docblock-short"><p>The result of checking command line arguments. Contains a vector
of matches and a vector of free strings.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Options.html" title="getopts::Options struct">Options</a></div><div class="item-right docblock-short"><p>A description of the options that a program can handle.</p>
</div></div></div><h2 id="enums" class="small-section-header"><a href="#enums">Enums</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.Fail.html" title="getopts::Fail enum">Fail</a></div><div class="item-right docblock-short"><p>The type returned when the command line does not conform to the
expected format. Use the <code>Debug</code> implementation to output detailed
information.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.HasArg.html" title="getopts::HasArg enum">HasArg</a></div><div class="item-right docblock-short"><p>Describes whether an option has an argument.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.Occur.html" title="getopts::Occur enum">Occur</a></div><div class="item-right docblock-short"><p>Describes how often an option may occur.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.ParsingStyle.html" title="getopts::ParsingStyle enum">ParsingStyle</a></div><div class="item-right docblock-short"><p>What parsing style to use when parsing arguments.</p>
</div></div></div><h2 id="types" class="small-section-header"><a href="#types">Type Definitions</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="type" href="type.Result.html" title="getopts::Result type">Result</a></div><div class="item-right docblock-short"><p>The result of parsing a command line with a set of options.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="getopts" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>